// OmkListCtrl.cpp :  Դϴ.
//

#include "stdafx.h"
#include "OmkListCtrl.h"
#include ".\omklistctrl.h"

#define VALID_ITEM_COUNT(nItem) { \
	ASSERT(m_hWnd);if((nItem >= GetItemCount())){ASSERT(FALSE);return FALSE;} }\

// COmkListCtrl

IMPLEMENT_DYNAMIC(COmkListCtrl, CWnd)
COmkListCtrl::COmkListCtrl()
{
	m_bRedraw	 = TRUE;
	m_clBack	 = CL_BACK;

	m_clBackItemSelected = CL_BACK_ITEM_SELECTED;
	m_clTextItemSelected = CL_TEXT_ITEM_SELECT;

	m_hFont		     = NULL;

	m_nItemHeight    = ITEM_HEIGHT;
	m_dwExtendStyle  = 0;
	m_nSelectItem    =-1;

	m_ptScroll = CPoint(0,0);
}

COmkListCtrl::~COmkListCtrl()
{
}


BEGIN_MESSAGE_MAP(COmkListCtrl, CWnd)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_MESSAGE(WM_SETFONT, OnSetFont)
	ON_WM_MOUSEWHEEL()
	ON_NOTIFY(HDN_ITEMCLICKA, HDR_CTRL_ID, OnHdnItemclick)
	ON_NOTIFY(HDN_ITEMCLICKW, HDR_CTRL_ID, OnHdnItemclick)
	ON_NOTIFY(HDN_BEGINTRACKA, HDR_CTRL_ID, OnHdnBegintrack)
	ON_NOTIFY(HDN_BEGINTRACKW, HDR_CTRL_ID, OnHdnBegintrack)
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)
END_MESSAGE_MAP()


BOOL COmkListCtrl::Create(DWORD dwStyle, CWnd *pParent, UINT uID, CRect rect)
{
	dwStyle |= (WS_VSCROLL | WS_HSCROLL |WS_TABSTOP);

	return CWnd::Create(NULL, _T(""), dwStyle, rect, pParent, uID);
}

int COmkListCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if(!m_pHdrCtrl.Create(NULL, "", WS_CHILD | WS_VISIBLE, CRect(0,0,0,0), this, HDR_CTRL_ID))
	{
		TRACE("Header Ctrl Create Faild\n");
		return -1;
	}

	m_pHdrCtrl.SetItemHeight(HDR_CTRL_HEIGHT, FALSE);
	return 0;
}

void COmkListCtrl::OnPaint()
{
	CPaintDC dc(this); 

	CDC     pMemDC;
	CBitmap pMembit, * pOldBit;
	CRect   rect, rectHdr;
	GetClientRect(rect);

	rectHdr		   = rect;
	rectHdr.bottom = m_pHdrCtrl.GetItemHeight();

	int nDC = dc.SaveDC();
	dc.ExcludeClipRect(rectHdr);

	pMemDC.CreateCompatibleDC(&dc);
	pMembit.CreateCompatibleBitmap(&dc, rect.Width(), rect.Height());

	pOldBit = pMemDC.SelectObject(&pMembit);
	pMemDC.SetBkMode(TRANSPARENT);

	OnPaint(&pMemDC, rect);

	dc.BitBlt(0, 0, rect.Width(), rect.Height(), &pMemDC, 0,0, SRCCOPY);

	dc.RestoreDC(nDC);
	pMemDC.SelectObject(pOldBit);
	pMemDC.SetBkMode(BKMODE_LAST);
}

void COmkListCtrl::OnPaint(CDC * pDC, const CRect &rect)
{
	CRect rectClient = CRect(0,0, rect.Width(), rect.Height());
	pDC->FillSolidRect(rectClient, m_clBack);

	if (m_pHdrCtrl.GetItemCount() == 0 || GetItemCount() == 0) 
		return;

	LVITEMEX  lvItem;
	DRAWITEMSTRUCTEX lpDraw;

	memset(&lvItem, 0, sizeof(lvItem));

	lpDraw.hDC      = pDC->m_hDC;
	lpDraw.CtlID    = GetDlgCtrlID();
	lpDraw.CtlType  = ODT_LISTVIEW; 
	lpDraw.rcItem   = rectClient;
	lpDraw.hwndItem = m_hWnd;
	lpDraw.nColCount= m_pHdrCtrl.GetItemCount();
	lpDraw.arrTextAlign = new UINT[lpDraw.nColCount];

	for (int i =0; i < lpDraw.nColCount; i++)
	{
		m_pHdrCtrl.GetTextAlign(i, lpDraw.arrTextAlign[i]); 
	}

	HGDIOBJ hOldFont = NULL;
	int     nOldBkMode;

	nOldBkMode = pDC->SetBkMode(TRANSPARENT);
	if(m_hFont) hOldFont = pDC->SelectObject(m_hFont);

	lpDraw.rcItem.left += m_ptScroll.x;
	lpDraw.rcItem.right+= m_ptScroll.x;

	int nDrawStartPos = GetTopIndex();
	int nDrawEndPos   = (nDrawStartPos + GetCountPerPage()) < GetItemCount() ? (nDrawStartPos + GetCountPerPage()) : GetItemCount();

	for (int i = nDrawStartPos; i < nDrawEndPos ; i++)
	{
		lpDraw.itemID = i;
		lpDraw.rcItem.top    = (m_nItemHeight * i) + m_ptScroll.y;
		lpDraw.rcItem.bottom = (lpDraw.rcItem.top + m_nItemHeight);

		lvItem.iItem = i;

		if(GetItem(&lvItem))
		{
			lpDraw.clBack    = lvItem.clBack;
			lpDraw.clText    = lvItem.clText;
			lpDraw.itemState = lvItem.state;

			DrawItem(pDC, &lpDraw);
		}
	}

	pDC->SetBkMode(nOldBkMode);
	if(m_hFont) pDC->SelectObject(hOldFont);

	delete [] lpDraw.arrTextAlign;
}

void COmkListCtrl::DrawItem(CDC * pDC, const DRAWITEMSTRUCTEX* lpDraw)
{
	int nItemCalcWidth = 0;
	CRect rectItem;

	CString szItem;
	UINT    uTextAlign;
	int     nOldTextCl = pDC->SetTextColor(lpDraw->clText);
	
	BOOL    bIsCheckBox = (GetExtendedStyle() & LVS_EX_CHECKBOXES); 
	
	for (int i =0; i < lpDraw->nColCount; i++)
	{
		GetSubItemRect(lpDraw->itemID, i, rectItem);

		if (lpDraw->itemState & ODS_SELECTED)
			pDC->FillSolidRect(rectItem, m_clBackItemSelected);
		else
			pDC->FillSolidRect(rectItem, lpDraw->clBack);
		
		szItem = GetItemText(lpDraw->itemID, i);
		
		if(i == 0 && bIsCheckBox)
		{
			CRect rectChkBox = DrawCheckBox(pDC, rectItem, (lpDraw->itemState & ODS_CHECKED) );
			rectItem.left    = rectChkBox.right + 4;
		}

		if(!szItem.IsEmpty())
		{
			if (lpDraw->itemState & ODS_SELECTED)
				nOldTextCl = pDC->SetTextColor(m_clTextItemSelected);
			else
				nOldTextCl = pDC->SetTextColor(lpDraw->clText);
			
			rectItem.DeflateRect(TERM_TEXT,0);

			uTextAlign = DT_VCENTER | DT_SINGLELINE | lpDraw->arrTextAlign[i];
			pDC->DrawText(szItem, rectItem, uTextAlign);
			
			pDC->SetTextColor(nOldTextCl);
		}
	}
}

void COmkListCtrl::SetRedraw(BOOL bRedraw)
{
	m_bRedraw = bRedraw;
	CWnd::SetRedraw(bRedraw);

	if(m_bRedraw)
	{
		SetCalcScrollPos(m_rectList.Width(), m_rectList.Height());
		RedrawWindow();
	}
}

DWORD COmkListCtrl::SetExtendedStyle(DWORD dwNewStyle)
{
	ASSERT(m_hWnd);
	m_dwExtendStyle |= dwNewStyle;
	RedrawWindow();
	return m_dwExtendStyle;
}

void COmkListCtrl::SetItemHeight(int nHeight, BOOL bRedraw)
{
	ASSERT(m_hWnd);
	m_nItemHeight = nHeight;

	if(bRedraw)	RedrawWindow();
}

BOOL COmkListCtrl::GetItem(LVITEMEX *lvItem)
{
	VALID_ITEM_COUNT(lvItem->iItem);
	
	LVITEMEX * pItem = m_arrItems.GetAt(lvItem->iItem);

	memcpy(lvItem, pItem, sizeof(LVITEMEX));
	
	return TRUE;
}

BOOL COmkListCtrl::GetItemRect(int nItem, CRect &rect)
{
	VALID_ITEM_COUNT(nItem);

	CRect rectHdr;
	m_pHdrCtrl.GetItemRect(m_pHdrCtrl.GetItemCount()-1, rectHdr);

	rect        = m_rectList;
	rect.right  = rectHdr.right;
	rect.top    = (nItem * m_nItemHeight) + (m_ptScroll.y) + rect.top ;
	rect.bottom = (rect.top + m_nItemHeight);

	rect.DeflateRect(-1,0);
	return TRUE;
}

BOOL COmkListCtrl::GetSubItemRect(int nItem, int nSubItem, CRect &rect)
{
	VALID_ITEM_COUNT(nItem);

	CRect rectHdr;
	m_pHdrCtrl.GetItemRect(nSubItem, rectHdr);

	rect.left   = rectHdr.left  + 1;
	rect.right  = rectHdr.right + 1;
	rect.top    = (nItem * m_nItemHeight) + (m_ptScroll.y) + rectHdr.bottom ;
	rect.bottom = (rect.top + m_nItemHeight);

	rect.DeflateRect(1,1,0,0);

	return TRUE;
}

int COmkListCtrl::InsertColumn(int nCol, LPCTSTR szTitle, int nFormat, int nWidth, int nSubItem, int nTextCl, int nBackCl)
{
	ASSERT(m_hWnd);

	LVCOLUMN lvCol ={0};

	lvCol.mask     = LVIF_TEXT;
	lvCol.iSubItem = nSubItem;
	lvCol.pszText  = (LPSTR)szTitle;
	lvCol.cx       = nWidth;
	lvCol.fmt      = nFormat;

	return InsertColumn(nCol, &lvCol, nTextCl, nBackCl);
}

int COmkListCtrl::InsertColumn(int nCol, const LVCOLUMN* pColumn, int clText,int clBack)
{
	ASSERT(m_hWnd);

	//////////////////////////////////////////////////
	// ̺ Ʈ..
	nCol = m_pItemTables.InsertCol(nCol);

	m_pHdrCtrl.InsertColumn(nCol, pColumn);

	if(m_bRedraw)
	{
		//////////////////////////////////////////////////
		// Scroll Pos  
		SetCalcScrollPos(m_rectList.Width(), -1);
		
		RedrawWindow();
	}

	return nCol;
}

BOOL COmkListCtrl::DeleteColumn(int nCol)
{
	//////////////////////////////////////////////////
	// ̺ Ʈ..
	m_pItemTables.DeleteCol(nCol);
	//////////////////////////////////////////////////

	if(!m_pHdrCtrl.DeleteItem(nCol))
		return FALSE;

	//////////////////////////////////////////////////
	// Scroll Pos  
	if(m_bRedraw)
	{
		//////////////////////////////////////////////////
		// Scroll Pos  
		SetCalcScrollPos(m_rectList.Width(), -1);

		RedrawWindow();
	}

	return TRUE;
}

void COmkListCtrl::DeleteAllColumn()
{
	m_pHdrCtrl.DeleteAllItem();
	//////////////////////////////////////////////////
	// ̺ Ʈ..
	m_pItemTables.RemoveAll();
	//////////////////////////////////////////////////

	//////////////////////////////////////////////////
	// Scroll Pos  
	if(m_bRedraw)
	{
		SetCalcScrollPos(m_rectList.Width(), -1);
		RedrawWindow();
	}
}

/*
	 InsertItem(..) ȣ  ̸ ۸ ҴϿ,
	Insertӵ ٿش..

	!! : Ҵ Item ǿ InsertItem() ̿Ͽ   ϸ ʵȴ.
	SetItemText(..) SetItem() ؾ Ѵ.
*/
BOOL COmkListCtrl::SetAllocationItemCount(int nItemCount, LPCTSTR lpszItem, int nImage, int clText, int clBack)
{
	ASSERT(!(nItemCount < 0));

	int nOldCnt = m_arrItems.GetCount();
	int nNewCnt = nOldCnt + nItemCount;

	m_arrItems.SetSize(nNewCnt);

	LVITEMEX * lvitemEx;
	for (int i = nOldCnt; i < nNewCnt; i++)
	{
		lvitemEx = new LVITEMEX;
		memset(lvitemEx, 0, sizeof(LVITEMEX));
		
		lvitemEx->iItem  = i;
		lvitemEx->clBack = clBack;
		lvitemEx->clText = clText;
		lvitemEx->iImage = nImage;
		lvitemEx->pszText= (LPSTR)lpszItem;

		m_arrItems.SetAt(i, lvitemEx);
	}

	m_pItemTables.SetAllocationRow(nItemCount);

	return TRUE;
}

int COmkListCtrl::InsertItem(int nItem, LPCTSTR lpszItem, int nImage, int clText, int clBack)
{
	ASSERT(m_hWnd);

	LVITEM lvitem ={0};

	lvitem.iItem   = nItem;
	lvitem.mask    = LVIF_TEXT | LVIF_IMAGE;
	lvitem.pszText = (LPSTR)lpszItem;
	lvitem.iImage  = nImage;

	return InsertItem(&lvitem, clText, clBack);
}

int COmkListCtrl::InsertItem(int nItem, LPCTSTR lpszItem, int clText, int clBack)
{
	LVITEM lvitem={0};

	lvitem.iItem   = nItem;
	lvitem.mask    = LVIF_TEXT;
	lvitem.pszText = (LPSTR)lpszItem;

	return InsertItem(&lvitem, clText, clBack);
}

int COmkListCtrl::InsertItem(const LVITEM* pItem, int clText, int clBack)
{
	if (m_pHdrCtrl.GetItemCount() == 0)
		return -1;

	LVITEMEX *lvitem = new LVITEMEX;

	memcpy(lvitem, pItem, sizeof(LVITEM));
	lvitem->clText  = clText;
	lvitem->clBack  = clBack;

	if (lvitem->iItem > m_arrItems.GetSize())
		lvitem->iItem = m_arrItems.GetSize();

	m_arrItems.InsertAt(lvitem->iItem, lvitem);

	//////////////////////////////////////////////////
	// ̺ Ʈ..
	m_pItemTables.InsertRow(lvitem->iItem);
	m_pItemTables.SetData(0, lvitem->iItem, lvitem->pszText);
	//////////////////////////////////////////////////

	if(m_bRedraw)	
	{
		//////////////////////////////////////////////////
		// Scroll Pos  
		SetCalcScrollPos(-1, m_rectList.Height());

		CRect rectRedraw  = m_rectList;
		rectRedraw.top    = (lvitem->iItem * m_nItemHeight) + (m_ptScroll.y) + m_rectList.top ;
		
		if (rectRedraw.top <= m_rectList.bottom)
			RedrawWindow(rectRedraw);
	}

	return lvitem->iItem;
}

BOOL COmkListCtrl::SetItemText(int nItem, int nSubItem, LPCTSTR lpszText)
{
	m_pItemTables.SetData(nSubItem, nItem, (LPSTR)lpszText);

	if(m_bRedraw)
	{
		CRect rect;
		GetSubItemRect(nItem, nSubItem, rect);
		RedrawWindow(rect);
	}

	return TRUE;
}

CString COmkListCtrl::GetItemText(int nItem, int nSubItem) const  
{
	const CString szData = m_pItemTables.GetData(nSubItem, nItem);
	return szData;
}

BOOL COmkListCtrl::DeleteItem(int nItem)
{
	VALID_ITEM_COUNT(nItem);
	
	delete m_arrItems.GetAt(nItem);
	m_arrItems.RemoveAt(nItem);

	//////////////////////////////////////////////////
	// ̺ Ʈ..
	m_pItemTables.DeleteRow(nItem);
	//////////////////////////////////////////////////

	if(m_nSelectItem == nItem)
		m_nSelectItem = -1;

	if(m_bRedraw)
	{
		//////////////////////////////////////////////////
		// Scroll Pos  
		SetCalcScrollPos(-1, m_rectList.Height());

		CRect rectRedraw = m_rectList;
		rectRedraw.top = (nItem * m_nItemHeight) + (m_ptScroll.y) + m_rectList.top ;
	
		if (rectRedraw.top <= m_rectList.bottom)
			RedrawWindow(rectRedraw);
	}

	return TRUE;
}

BOOL COmkListCtrl::DeleteAllItems()
{
	m_nSelectItem = -1;

	//////////////////////////////////////////////////
	// ̺ Ʈ..
	m_pItemTables.DeleteAllRow();
	//////////////////////////////////////////////////

	for (int i =0; i < m_arrItems.GetSize(); i++)
		delete m_arrItems.GetAt(i);

	m_arrItems.RemoveAll();
	if(m_bRedraw) 
	{
		//////////////////////////////////////////////////
		// Scroll Pos  
		SetCalcScrollPos(-1, m_rectList.Height());
		
		RedrawWindow();
	}

	return TRUE;
}

void COmkListCtrl::OnDestroy()
{
	CWnd::OnDestroy();
	DeleteAllItems();
}

LRESULT COmkListCtrl::OnSetFont(WPARAM wParam, LPARAM lParam)
{
	Default();
	m_hFont = (HFONT)wParam;
	return m_pHdrCtrl.SendMessage(WM_SETFONT, wParam, lParam);
}

void COmkListCtrl::OnHdnItemclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	*pResult = 0;
}

void COmkListCtrl::OnHdnBegintrack(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	
	SetCalcScrollPos(m_rectList.Width(), -1);

	RedrawWindow();
	*pResult = 0;
}

void COmkListCtrl::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	ASSERT(m_pHdrCtrl.GetSafeHwnd());

	CRect rectHdr;

	m_rectList = CRect(0, 0, cx, cy);
	m_rectList.DeflateRect(TERM_WIDTH, TERM_HEIGHT);

	rectHdr        = m_rectList;
	rectHdr.bottom = m_rectList.top = m_pHdrCtrl.GetItemHeight();

	m_pHdrCtrl.MoveWindow(rectHdr);

	SetCalcScrollPos(cx, (cy - rectHdr.Height()));
}

void COmkListCtrl::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO si ={0};

	GetScrollInfo(SB_VERT ,&si,SIF_ALL);
	nPos = si.nTrackPos;

	switch(nSBCode)
	{
	case SB_LINEUP:
		si.nPos-=si.nPage;
		break;
	case SB_LINEDOWN:
		si.nPos+=si.nPage;
		break;
	case SB_PAGEUP:
		si.nPos-=si.nPage;
		break;
	case SB_PAGEDOWN:
		si.nPos+=si.nPage;
		break;
	case SB_THUMBTRACK:
		si.nPos=nPos;
		break;
	}
	if(si.nPos>(int)(si.nMax-si.nMin-si.nPage+1)) si.nPos=si.nMax-si.nMin-si.nPage+1;
	if(si.nPos<si.nMin) si.nPos=si.nMin;

	m_ptScroll.y    = -si.nPos;

	SetScrollInfo(SB_VERT ,&si);

	RedrawWindow();

	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}

void COmkListCtrl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO si ={0};

	GetScrollInfo(SB_HORZ ,&si, SIF_ALL);
	nPos = si.nTrackPos;

	switch(nSBCode)
	{
	case SB_LINELEFT:
		si.nPos-=si.nPage;
		break;
	case SB_LINERIGHT:
		si.nPos+=si.nPage;
		break;
	case SB_PAGELEFT:
		si.nPos-=si.nPage;
		break;
	case SB_PAGEDOWN:
		si.nPos+=si.nPage;
		break;
	case SB_THUMBTRACK:
		si.nPos=nPos;
		break;
	}

	if(si.nPos>(int)(si.nMax-si.nMin-si.nPage+1)) si.nPos=si.nMax-si.nMin-si.nPage+1;
	if(si.nPos<si.nMin) si.nPos=si.nMin;
	
	m_ptScroll.x    = -si.nPos;
	m_pHdrCtrl.SetScrollPosWidth(m_ptScroll.x);

	SetScrollInfo(SB_HORZ ,&si);
	
	RedrawWindow();
	CWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COmkListCtrl::SetCalcScrollPos(const int nWidth, const int nHeight)
{
	SCROLLINFO info;
	info.cbSize = sizeof(SCROLLINFO);     

	info.fMask	   = SIF_ALL;     
	info.nMin      = 0;     
	info.nPos      = 0;    
	info.nTrackPos = 0;

	if(nWidth != -1)
	{
		GetScrollInfo(SB_HORZ ,&info, SIF_ALL);

		const int nScrollWidth  = m_pHdrCtrl.GetTotalItemWidth();

		if (nWidth >= nScrollWidth)
		{
			info.nMax  = nScrollWidth; 
			info.nPage = nScrollWidth;     
			SetScrollRange(SB_HORZ, 0, 0, TRUE);

			m_pHdrCtrl.SetScrollPosWidth(0);
			m_ptScroll.x = 0;
		}
		else
		{
			ReCalcScrollWidth(info, nWidth);
		}
	}

	if (nHeight != -1)
	{
		const int nScrollHeight = GetItemCount() * m_nItemHeight ;
		if (nHeight >= nScrollHeight)
		{
			info.nMax  = nScrollHeight; 
			info.nPage = nScrollHeight;     
			SetScrollRange(SB_VERT, 0,0,TRUE);
		}
		else
		{
			info.nMax  = nScrollHeight; 
			info.nPage = nHeight;     
			SetScrollInfo(SB_VERT, &info, TRUE );
		}
	}
}

/*
	Ʈŷ  ̵ɶ(پ鶧) ũ   쿡
	˻Ͽ   ش..
*/
void COmkListCtrl::ReCalcScrollWidth(SCROLLINFO &info, const int nWidth)
{
	const int TERM_TRACK_WIDTH = 1;

	CRect rectItem;
	int   nCalcWidth =0, nScrollWidth =0, nSumWidth =0;

	for (int i =m_pHdrCtrl.GetItemCount()-1; i > 0 ; i--)
	{
		nScrollWidth  = m_pHdrCtrl.GetTotalItemWidth();
		if (nWidth >= nScrollWidth)	break;
		else
		{
			m_pHdrCtrl.GetItemRect(i, rectItem);

			if (rectItem.right > (nWidth + nSumWidth - TERM_TRACK_WIDTH))
				break;

			m_pHdrCtrl.ReleaseTraking();

			nCalcWidth    = rectItem.Width()- (nScrollWidth - nWidth);
			m_ptScroll.x += rectItem.Width() - nCalcWidth;

			if(m_ptScroll.x > 0) m_ptScroll.x =0;

			m_pHdrCtrl.SetScrollPosWidth(m_ptScroll.x);

			nCalcWidth  -= TERM_TRACK_WIDTH;

			if(nCalcWidth < 0 )
			{
				nSumWidth  = -nCalcWidth;
				nCalcWidth = 0;
			}

			m_pHdrCtrl.SetItemWidth(i, nCalcWidth);
		}
	}

	info.nMax  = m_pHdrCtrl.GetTotalItemWidth(); 
	info.nPage = nWidth;     
	SetScrollInfo(SB_HORZ, &info, TRUE );
}

void COmkListCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	CWnd::SetFocus();

	int nSelectItem, nSubItem;
	if(!GetSelectedItemPos(point, nSelectItem, nSubItem))	
		return;
	
	NMLISTVIEW stNmList = {0}; 
	UINT uCtlID = GetDlgCtrlID();
	
	stNmList.hdr.hwndFrom	= m_hWnd;
	stNmList.hdr.idFrom     = uCtlID;
	stNmList.hdr.code       = NM_CLICK;
	stNmList.iItem			= nSelectItem;
	stNmList.iSubItem		= nSubItem;
	stNmList.ptAction		= point;
	stNmList.uNewState		= LVIS_SELECTED;

	GetParent()->SendMessage(WM_NOTIFY, uCtlID, (LPARAM)&stNmList);

	SetSelectionMark(nSelectItem);

	CWnd::OnLButtonDown(nFlags, point);
}


void COmkListCtrl::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	NM_LISTVIEW *pList = (NM_LISTVIEW*)pNMHDR;

	if( (GetExtendedStyle() & LVS_EX_CHECKBOXES) && pList->iSubItem == 0)
	{
		CRect rectItem, rectChkBox;
		GetSubItemRect(pList->iItem, 0, rectItem  );

		rectChkBox = MakeChekBoxRect(rectItem);

		if(rectChkBox.PtInRect(pList->ptAction))
		{
			SetCheck(pList->iItem, !GetCheck(pList->iItem), FALSE);
			RedrawWindow(rectChkBox);
		}
	}

	*pResult = 0;
}

BOOL COmkListCtrl::SetCheck(int nItem, BOOL bCheck, BOOL bRedraw)
{
	VALID_ITEM_COUNT(nItem);

	LVITEMEX * lvitem = m_arrItems.GetAt(nItem);

	if (bCheck)	lvitem ->state |= ODS_CHECKED;
	else		lvitem ->state &= ~ODS_CHECKED;

	if(bRedraw)
	{
		
	}

	return TRUE;
}

BOOL COmkListCtrl::GetCheck(int nItem)
{
	VALID_ITEM_COUNT(nItem);
	LVITEMEX * lvitem = m_arrItems.GetAt(nItem);
	return (lvitem->state & ODS_CHECKED);
}

BOOL COmkListCtrl::GetSelectedItemPos(const CPoint &point, int &nItem, int &nSubItem)
{
	nSubItem = -1;
	nItem    = (point.y - m_rectList.top + abs(m_ptScroll.y)) / m_nItemHeight;

	if(nItem >= GetItemCount())
		return FALSE;

	CRect rect, rectHdr;
	GetItemRect(nItem, rect);

	if (!rect.PtInRect(point))
		return FALSE;

	for (int i =0; i < m_pHdrCtrl.GetItemCount(); i++)
	{
		m_pHdrCtrl.GetItemRect(i, rectHdr);
			
		rect.left  = rectHdr.left;
		rect.right = rectHdr.right;
	
		if (rect.PtInRect(point))
		{
			nSubItem = i;
			break;
		}
	}

	return TRUE;
}

int COmkListCtrl::SetSelectionMark(int iItem)
{
	VALID_ITEM_COUNT(iItem);

	if(m_bRedraw)
	{
		CRect rectItem;

		if(m_nSelectItem != -1)
		{
			LVITEMEX*  pOldSeleteItem = m_arrItems.GetAt(m_nSelectItem);
			pOldSeleteItem->state &= ~ODS_SELECTED;

			GetItemRect(m_nSelectItem, rectItem);
			RedrawWindow(rectItem);
		}

		LVITEMEX*  pSeleteItem = m_arrItems.GetAt(iItem);
		pSeleteItem->state |= ODS_SELECTED;

		GetItemRect(iItem, rectItem);
		RedrawWindow(rectItem);

		RedrawWindow(rectItem);
	}

	m_nSelectItem = iItem;

	return m_nSelectItem;
}

BOOL COmkListCtrl::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	SCROLLINFO si ={0};
	GetScrollInfo(SB_VERT ,&si,SIF_ALL);

	if (zDelta == WHEEL_DELTA)
	{
		si.nPos-=m_nItemHeight;
		
		if(si.nPos>(int)(si.nMax-si.nMin-si.nPage+1)) si.nPos=si.nMax-si.nMin-si.nPage+1;
		if(si.nPos<si.nMin) si.nPos=si.nMin;

		m_ptScroll.y    = -si.nPos;
	}
	else
	{
		si.nPos+=m_nItemHeight;

		if(si.nPos>(int)(si.nMax-si.nMin-si.nPage+1)) si.nPos=si.nMax-si.nMin-si.nPage+1;
		if(si.nPos<si.nMin) si.nPos=si.nMin;

		m_ptScroll.y    = -si.nPos;
	}

	SetScrollInfo(SB_VERT ,&si);
	RedrawWindow();
	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}

CRect COmkListCtrl::DrawCheckBox(CDC *pDC, const CRect &rect, const BOOL & bCheck)
{
	CRect rectChkBox = MakeChekBoxRect(rect);

	pDC->FillSolidRect(rectChkBox, RGB(153,153,153));

	rectChkBox.DeflateRect(2,2);
	pDC->FillSolidRect(rectChkBox, RGB(255,255,255));

	rectChkBox.DeflateRect(1,1);

	if(bCheck)
	{
		const int nChkSize = 11;
		CPoint    ptChk = CSize(2,2);
		CDC pMemDC;
		CBitmap pMemBit,*pOlBit;

		pMemDC.CreateCompatibleDC(pDC);
		pMemBit.CreateCompatibleBitmap(pDC, nChkSize, nChkSize);
		pOlBit = pMemDC.SelectObject(&pMemBit);
		pMemDC.FillSolidRect(0,0,nChkSize,nChkSize, RGB(255,255,255));

		pMemDC.MoveTo( ptChk.x + 0, ptChk.y + 2);
		pMemDC.LineTo( ptChk.x + 0, ptChk.y + 5); 

		pMemDC.MoveTo( ptChk.x + 1, ptChk.y + 3);
		pMemDC.LineTo( ptChk.x + 1, ptChk.y + 6);

		pMemDC.MoveTo( ptChk.x + 2, ptChk.y + 4);
		pMemDC.LineTo( ptChk.x + 2, ptChk.y + 7);

		pMemDC.MoveTo( ptChk.x + 3, ptChk.y + 3);
		pMemDC.LineTo( ptChk.x + 3, ptChk.y + 6);

		pMemDC.MoveTo( ptChk.x + 4, ptChk.y + 2);
		pMemDC.LineTo( ptChk.x + 4, ptChk.y + 5);

		pMemDC.MoveTo( ptChk.x + 5, ptChk.y + 1);
		pMemDC.LineTo( ptChk.x + 5, ptChk.y + 4);

		pMemDC.MoveTo( ptChk.x + 6, ptChk.y + 0);
		pMemDC.LineTo( ptChk.x + 6, ptChk.y + 3);

		pDC->StretchBlt(rectChkBox.left, rectChkBox.top, rectChkBox.Width(), rectChkBox.Height(),
			&pMemDC, 0,0,nChkSize,nChkSize,SRCCOPY);
		pMemDC.SelectObject(pOlBit);
	}

	return rectChkBox;
}

CRect COmkListCtrl::MakeChekBoxRect(const CRect &rect)
{
	CRect rectChkBox;

	rectChkBox.top    = rect.top;
	rectChkBox.bottom = rect.bottom;
	rectChkBox.left   = 2;
	rectChkBox.right  = rect.Height();

	rectChkBox.DeflateRect(4,4);

	return rectChkBox;
}