// OmkListHdrCtrl.cpp :  Դϴ.
//

#include "stdafx.h"
#include "OmkListHdrCtrl.h"
#include ".\omklisthdrctrl.h"


// COmkListHdrCtrl

#define VALID_COL_COUNT(nItem) { \
	if((nItem >= GetItemCount())){ASSERT(FALSE);return FALSE;} }\

IMPLEMENT_DYNAMIC(COmkListHdrCtrl, CWnd)
COmkListHdrCtrl::COmkListHdrCtrl()
{
	m_hFont		  = NULL;
	m_nItemHeight = 0;
	m_nScrollXPos = 0;

	m_emTracking      = TRAKING_MODE_DEFAULT;
	m_nTrackingItem   = -1;
	m_nHdrClickedItem = -1;
	m_hTrackingCursor = LoadCursor(NULL, IDC_SIZENESW); 

	m_clBack	 = CL_BACK;
	m_clItemBack = CL_ITEM_BACK;
	m_clItemText = CL_TEXT;
	m_clBorderTopLeft     = CL_BORDER_TOPLEFT;
	m_clBorderBottomRight = CL_BORDER_BOTTOMRIGHT;
}

COmkListHdrCtrl::~COmkListHdrCtrl()
{
	if(m_hTrackingCursor)
		::DestroyCursor(m_hTrackingCursor);
}


BEGIN_MESSAGE_MAP(COmkListHdrCtrl, CWnd)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_MOUSEMOVE()
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
	ON_MESSAGE(WM_SETFONT, OnSetFont)
END_MESSAGE_MAP()


int COmkListHdrCtrl::InsertColumn(int nCol, const LVCOLUMN* pColumn)
{
	ASSERT(m_hWnd);

	LVCOLUMNEX * lvItem = new LVCOLUMNEX;

	memcpy(lvItem, pColumn, sizeof(LVCOLUMN));
	
	m_arrItems.InsertAt(nCol, lvItem);
	ReCalcItemSize(nCol);		// ÷  Ͽ ش.

	RedrawWindow();
	return nCol;
}

BOOL COmkListHdrCtrl::SetItemText(int nItem, int nSubItem, LPCTSTR lpszText)
{
	return TRUE;
}

CImageList* COmkListHdrCtrl::SetImageList(CImageList* pImageList)
{
	return NULL;
}

BOOL COmkListHdrCtrl::SetItemWidth(int nItem, int nWidth, BOOL bRedraw)
{
	VALID_COL_COUNT(nItem);

	int nWidth1  = m_arrItems.GetAt(nItem)->cx;
	m_arrItems.GetAt(nItem)->cx = nWidth;

	ReCalcItemSize(nItem);
	
	if(bRedraw)	RedrawWindow();

	return TRUE;
}

BOOL COmkListHdrCtrl::GetItemWidth(int nItem, int &nWidth)
{
	VALID_COL_COUNT(nItem);

	nWidth = m_arrItems.GetAt(nItem)->cx;
	return TRUE;
}

int COmkListHdrCtrl::GetTotalItemWidth()
{
	int nWidth = 0;

	for (int i =0; i < GetItemCount(); i++)
		nWidth += m_arrItems.GetAt(i)->cx;

	return nWidth;
}

void COmkListHdrCtrl::SetItemHeight(int nHeight, BOOL bRedraw)
{
	LVCOLUMNEX * pItem;
	
	m_nItemHeight = nHeight;
	for (int i = 0; i < GetItemCount(); i++)
	{
		pItem = m_arrItems.GetAt(i);
		
		pItem->rectItem.top    = 0;
		pItem->rectItem.bottom = nHeight;
	}

	if(bRedraw)	RedrawWindow();
}

BOOL COmkListHdrCtrl::DeleteItem(int nCol)
{
	VALID_COL_COUNT(nCol);

	delete m_arrItems.GetAt(nCol);
	m_arrItems.RemoveAt(nCol);

	if(m_arrItems.GetSize() != 0 && m_arrItems.GetSize() != nCol)	
		ReCalcItemSize(nCol);

	return TRUE;
}

BOOL COmkListHdrCtrl::DeleteAllItem()
{
	for (int i =0; i < m_arrItems.GetSize(); i++)
		delete m_arrItems.GetAt(i);

	m_arrItems.RemoveAll();

	return TRUE;
}

void COmkListHdrCtrl::SetScrollPosWidth(int nWidth)
{
	m_nScrollXPos = nWidth;

	if(GetItemCount() !=0)
		ReCalcItemSize();
}

/*
	 Item Rect()  ؼ  ̺Ʈ Item Rect() ̸ Ѵ.
	-  ߰,
	-  ,
	-  ũ(width) ..
	- Ʈŷ  
*/
BOOL COmkListHdrCtrl::ReCalcItemSize(int nStartItem)
{
	VALID_COL_COUNT(nStartItem);

	LVCOLUMNEX* lvColumnPrev;
	LVCOLUMNEX* lvColumn;    

	RECT rectItem;
	rectItem.top    = 0;
	rectItem.bottom = m_nItemHeight-1;

	for (int i = nStartItem; i < GetItemCount(); i++)
	{
		if(i == 0)
		{
			lvColumn       = m_arrItems.GetAt(i);
			rectItem.left  = m_nScrollXPos;
			rectItem.right = lvColumn->cx + m_nScrollXPos;
		}
		else
		{
			lvColumnPrev = m_arrItems.GetAt(i-1);
			lvColumn     = m_arrItems.GetAt(i);

			rectItem.left = lvColumnPrev->rectItem.right;
			rectItem.right= rectItem.left + lvColumn->cx;
		}

		lvColumn->rectItem = rectItem;
	}

	return TRUE;
}

BOOL COmkListHdrCtrl::GetItem(int nItem, LVCOLUMN *lvCol)
{
	ASSERT(m_hWnd);
	VALID_COL_COUNT(nItem);

	lvCol = m_arrItems.GetAt(nItem);

	return TRUE;
}

// COmkListHdrCtrl ޽ óԴϴ.
int COmkListHdrCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;


	return 0;
}

void COmkListHdrCtrl::OnPaint()
{
	CPaintDC dc(this); 
	
	CRect rect;
	GetClientRect(rect);

	CDC		pMemDC;
	CBitmap pMemBit;

	pMemDC.CreateCompatibleDC(&dc);
	pMemBit.CreateCompatibleBitmap(&dc, rect.Width(), rect.Height());
	
	pMemDC.SelectObject(&pMemBit);

	OnPaint(&pMemDC, rect);

	dc.BitBlt(0,0, rect.Width(), rect.Height(), &pMemDC, 0, 0, SRCCOPY);
}

void COmkListHdrCtrl::OnPaint(CDC *pDC, const CRect &rect)
{
	HGDIOBJ hOldFont = NULL;
	int nOldBkMode, nOldTextCl;
	CRect rectItem;
	
	if(m_hFont)	hOldFont = pDC->SelectObject(m_hFont);
	
	nOldBkMode = pDC->SetBkMode(TRANSPARENT);
	nOldTextCl = pDC->SetTextColor(m_clItemText);

	pDC->FillSolidRect(rect, m_clBack);
	
	LVCOLUMNEX * pItem = NULL;
	for (int i =0; i < m_arrItems.GetSize(); i++)
	{
		pItem    = m_arrItems.GetAt(i);
		rectItem = pItem->rectItem;

		DrawItem(pDC, pItem->rectItem, pItem, (m_nHdrClickedItem == i));

		if(pItem->rectItem.left > rect.right)	 //    쿡 ׸ ʿ䰡 .
		{
			pItem = NULL;
			break;
		}
	}	

	///////     ߻ϸ ش  ׷ش..
	if(pItem)
	{
		CRect rectBlank;
		rectBlank = rect;

		rectBlank.left  = pItem->rectItem.right;
		rectBlank.right = rect.right+1;
		DrawItem(pDC, rectBlank, NULL, FALSE);
	}

	pDC->SetBkMode(nOldBkMode);
	pDC->SetTextColor(nOldTextCl);

	if(m_hFont)	pDC->SelectObject(hOldFont);
}

void COmkListHdrCtrl::DrawItem(CDC *pDC, const CRect &rect, LVCOLUMNEX * pItem, BOOL bClicked)
{
	CRect rectItem = rect;

	rectItem.DeflateRect(1,1,0,1);

	pDC->FillSolidRect(rectItem, m_clItemBack);

	if(bClicked)
	{
		rectItem.bottom ++; 
		pDC->Draw3dRect(rectItem, m_clBorderBottomRight, m_clBorderBottomRight);
	}
	else
	{
		pDC->Draw3dRect(rectItem, m_clBorderTopLeft, m_clBorderBottomRight);
	}

	if(pItem == NULL)	return;

	UINT uTextAlign = DT_SINGLELINE | DT_VCENTER;

	if(pItem->fmt & LVCFMT_LEFT)
		uTextAlign |= DT_LEFT;
	else if (pItem->fmt & LVCFMT_CENTER)
		uTextAlign |= DT_CENTER;
	else if (pItem->fmt & LVCFMT_RIGHT)
		uTextAlign |= DT_RIGHT;
	
	const int TERM_TEXT = 2;			// ؽƮ  ̻ڰ ϱ ؼ...
	rectItem.DeflateRect(TERM_TEXT,0);

	pDC->DrawText(pItem->pszText, rectItem, uTextAlign);
}

BOOL COmkListHdrCtrl::GetTextAlign(int nItem, UINT &uAlign)
{
	VALID_COL_COUNT(nItem);

	LVCOLUMNEX * pItem = m_arrItems.GetAt(nItem);

	uAlign = DT_LEFT;

	if(pItem->fmt & LVCFMT_LEFT)
		uAlign = DT_LEFT;
	else if (pItem->fmt & LVCFMT_CENTER)
		uAlign = DT_CENTER;
	else if (pItem->fmt & LVCFMT_RIGHT)
		uAlign = DT_RIGHT;

	return TRUE;
}

LRESULT COmkListHdrCtrl::OnSetFont(WPARAM wParam, LPARAM lParam)
{
	m_hFont = (HFONT)wParam;
	Default();
	return S_OK;
}

void COmkListHdrCtrl::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);
}

void COmkListHdrCtrl::OnDestroy()
{
	CWnd::OnDestroy();

	DeleteAllItem();
}

BOOL COmkListHdrCtrl::GetItemRect(int nItem, CRect &rect)
{
	VALID_COL_COUNT(nItem);
	rect = m_arrItems.GetAt(nItem)->rectItem;
	return TRUE;
}

void COmkListHdrCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	CWnd::OnLButtonDown(nFlags, point);

	if(m_emTracking == TRAKING_MODE_FOCUS)
	{
		m_emTracking = TRAKING_MODE_ACTIVE;
		SetCapture();		
		return;
	}
	
	CheckHdrItemClickded(point);
}

void COmkListHdrCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	CWnd::OnMouseMove(nFlags, point);
	if( m_emTracking == TRAKING_MODE_ACTIVE )
	{
		LVCOLUMNEX * pItem = m_arrItems.GetAt(m_nTrackingItem);

		pItem->cx = (point.x - m_nTrackStartXPos);

		// Ʈŷ   ش  Width 1 Ѵ.
		if(pItem->cx <= 1)	
			pItem->cx = 1; 

		ReCalcItemSize(m_nTrackingItem);
		OnHdnBegintrack(m_nTrackingItem);
		return;
	}

	CheckHdrBeginTrack(point);
}

void COmkListHdrCtrl::ReleaseTraking()
{
	m_emTracking      = TRAKING_MODE_DEFAULT;
	m_nTrackingItem   = -1;
	m_nTrackStartXPos = 0;

	// 콺 ĸ 
	ReleaseCapture();
}

void COmkListHdrCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(IsTraking())
	{
		ReleaseTraking();
	}
	else
	{
		OnHdnItemclick(m_nHdrClickedItem);
		
		m_nHdrClickedItem = -1;
		RedrawWindow();
	}

	CWnd::OnLButtonUp(nFlags, point);
}

void COmkListHdrCtrl::OnHdnItemclick(int nItem)
{
	UINT uCtlID = GetDlgCtrlID();
	NMHEADERA hdr ={0};

	hdr.hdr.hwndFrom = m_hWnd;
	hdr.hdr.idFrom   = uCtlID;
	hdr.hdr.code     = HDN_ITEMCLICKA;
	hdr.iItem        = nItem;

	GetParent()->SendMessage(WM_NOTIFY, uCtlID, (LPARAM)&hdr);
}

void COmkListHdrCtrl::OnHdnBegintrack(int nItem)
{
	UINT uCtlID = GetDlgCtrlID();
	NMHEADERA hdr ={0};

	hdr.hdr.hwndFrom = m_hWnd;
	hdr.hdr.idFrom   = uCtlID;
	hdr.hdr.code     = HDN_BEGINTRACKA;
	hdr.iItem        = nItem;

	GetParent()->SendMessage(WM_NOTIFY, uCtlID, (LPARAM)&hdr);
}

LRESULT COmkListHdrCtrl::OnMouseLeave(WPARAM wParam, LPARAM lParam)
{
	m_nHdrClickedItem = -1;
	RedrawWindow();

	return TRUE;
}

void COmkListHdrCtrl::CheckLeave(CPoint point)
{
	TRACKMOUSEEVENT EventTrack;

	EventTrack.cbSize		= sizeof(TRACKMOUSEEVENT);
	EventTrack.dwFlags		= TME_LEAVE;
	EventTrack.hwndTrack	= m_hWnd;
	EventTrack.dwHoverTime  = 0;

	_TrackMouseEvent(&EventTrack);
}

void COmkListHdrCtrl::CheckHdrItemClickded(const CPoint &point)
{
	m_nHdrClickedItem = -1;

	CRect	     rectCalc;
	LVCOLUMNEX * pItem;

	for (int i =0; i < GetItemCount(); i++)
	{
		pItem    = m_arrItems.GetAt(i);
		rectCalc = pItem->rectItem;

		if (rectCalc.PtInRect(point))
		{
			m_nHdrClickedItem = i;
			RedrawWindow(rectCalc);
			CheckLeave(point);
			break;
		}
	}
}

void COmkListHdrCtrl::CheckHdrBeginTrack(const CPoint &point)
{
	m_emTracking     = TRAKING_MODE_DEFAULT;
	m_nTrackingItem = -1;

	CRect rectTrack;

	for (int i =m_arrItems.GetSize()-1; i >= 0; i--)
	{
		LVCOLUMNEX * pItem = m_arrItems.GetAt(i);

		rectTrack       = pItem->rectItem;
		rectTrack.left  = pItem->rectItem.right - TERM_TRACK_WIDTH;
		rectTrack.right = pItem->rectItem.right + TERM_TRACK_WIDTH;

		if (rectTrack.PtInRect(point))
		{
			m_nTrackStartXPos = pItem->rectItem.left;
			m_nTrackingItem   = i;
			m_emTracking      = TRAKING_MODE_FOCUS;
			break;
		}
	}
}

BOOL COmkListHdrCtrl::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	if(m_emTracking != TRAKING_MODE_DEFAULT)
	{
		SetCursor(m_hTrackingCursor);
		return TRUE;
	}

	return CWnd::OnSetCursor(pWnd, nHitTest, message);
}
