#pragma once


// COmkListHdrCtrl
#include <afxtempl.h>

class COmkListHdrCtrl : public CWnd
{
	DECLARE_DYNAMIC(COmkListHdrCtrl)

public:
	COmkListHdrCtrl();
	virtual ~COmkListHdrCtrl();

	enum
	{
		CL_BACK				  = RGB(64,64,64),
		CL_BORDER_TOPLEFT     = RGB(255,255,255),
		CL_BORDER_BOTTOMRIGHT = RGB(128,128,128),
		CL_TEXT				  = RGB(0,0,0),
		CL_ITEM_BACK		  = RGB(212,208,200),
	};

	typedef struct LVCOLUMNEX :public LVCOLUMN 
	{
		RECT rectItem;
	}LVCOLUMNWEX, *LPLVCOLUMNWEX;

	enum
	{
		TERM_TRACK_WIDTH = 4,
	};

	enum _emTrakingMode
	{
		TRAKING_MODE_DEFAULT,
		TRAKING_MODE_FOCUS,
		TRAKING_MODE_ACTIVE,
	};

public:
	int GetTotalItemWidth();
	inline int GetItemCount() {return int(m_arrItems.GetSize());}
	inline int GetItemHeight(){return m_nItemHeight;}
	void SetScrollPosWidth(int nWidth);
	int InsertColumn(int nCol, const LVCOLUMN* pColumn);

	BOOL SetItemWidth(int nItem, int nWidth, BOOL bRedraw = TRUE);
	void SetItemHeight(int nHeight, BOOL bRedraw = TRUE);
	BOOL SetItemText(int nItem, int nSubItem, LPCTSTR lpszText);
	BOOL DeleteItem(int nPos);
	BOOL DeleteAllItem();
	BOOL GetItem(int nItem, LVCOLUMN *lvCol);
	BOOL GetItemWidth(int nItem, int &nWidth);
	BOOL GetTextAlign(int nItem, UINT &uAlign);

	BOOL GetItemRect(int nItem, CRect &rect);
	CImageList* SetImageList(CImageList* pImageList);

	void ReleaseTraking();
	virtual void OnPaint(CDC *pDC, const CRect &rect);
	void DrawItem(CDC *pDC, const CRect &rect, LVCOLUMNEX * pItem, BOOL bClicked);
	void OnHdnItemclick(int nItem);
	void OnHdnBegintrack(int nItem);
	
protected:
	DECLARE_MESSAGE_MAP()

	CArray <LVCOLUMNEX*> m_arrItems;
	CImageList m_pImageList; 
	HFONT	   m_hFont;
	int		   m_nItemHeight;
	int		   m_nScrollXPos;


	_emTrakingMode m_emTracking;
	HCURSOR		   m_hTrackingCursor;
	int			   m_nTrackingItem;
	int			   m_nTrackStartXPos;

	BOOL		   m_bMouseClicked;
	int			   m_nHdrClickedItem;

	COLORREF m_clBack;
	COLORREF m_clBorderTopLeft;
	COLORREF m_clBorderBottomRight;
	COLORREF m_clItemBack;
	COLORREF m_clItemText;

	void CheckLeave(CPoint point);
	void CheckHdrBeginTrack(const CPoint &point);
	void CheckHdrItemClickded(const CPoint &point);
	BOOL ReCalcItemSize(int nStartItem = 0);

	inline BOOL IsTraking() {return (m_emTracking == TRAKING_MODE_FOCUS || m_emTracking == TRAKING_MODE_ACTIVE);}

public:
	afx_msg LRESULT OnSetFont(WPARAM wParam, LPARAM lParam);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg LRESULT OnMouseLeave(WPARAM wParam, LPARAM lParam);

};


